#ifndef MYHEADER_H
#define MYHEADER_H

#include <ultra64.h>

#define TEXTURE_INIT(w, h, pix, pal, f)	\
{ .width = w, .height = h, .pixels = pix, .palette = pal, .fmt = f }

typedef enum {
	TEXTURE_FMT_CI4,
	TEXTURE_FMT_RGBA16,
	TEXTURE_FMT_RGBA32,
        TEXTURE_FMT_UNKNOWN
} TextureFormat;

typedef struct {
	u16		width;
	u16		height;
	void*		pixels;
	void*		palette;
	TextureFormat	fmt;
} Texture;

typedef struct {
	float	x;
	float	y;
	float	z;
} Vector3f;

typedef struct {
	Vector3f	color;
	Texture*	tex;
} Material;

typedef struct {
	Material* mat;
	Gfx* gfx;
} Pair;

#endif	/* MYHEADER_H */

